; 
    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\msvcrt.lib

    include \masm32\macros\macros.asm

    include timers.asm
; 
    .data
    .code
; 
start: 
; 
    LOOP_COUNT EQU 10000000

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS

      push 12345678
      xor ecx, ecx
      xor eax, eax
      bsr edx, [esp]
      and edx, -2 ; even
      bts ecx, edx
  s0: add eax, ecx
      sub [esp], eax
      jnc s1
      add [esp], eax
      sub eax, ecx
      jmp s2

  s1: add eax, ecx
  s2: shr eax, 1
      shr ecx, 2
      jne s0
      pop eax

    counter_end
    print ustr$(eax)
    print chr$(" cycles",13,10)

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS

      push 12345678
      fwait
      fild dword ptr [esp]
      fsqrt
      fistp dword ptr [esp]
      fwait
      pop eax

    counter_end
    print ustr$(eax)
    print chr$(" cycles",13,10)

    mov   eax, input(13,10,"Press enter to exit...")
    exit
; 
end start
